var xmlhttp = new XMLHttpRequest();
var downloadwithOS = "unix";
if (window.navigator.platform.toLowerCase().indexOf("win") != -1) {
	/* windows */
	downloadwithOS = "win";
}
var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"]
        .createInstance(nsIFilePicker);
fp.init(window, "Select the command", nsIFilePicker.modeOpen);
fp.appendFilters(nsIFilePicker.filterAll);

function onAccept() {
	if (document.getElementById("custom").selected) {
		window.opener.addApplication(document.getElementById("prefApplicationIdentification").value,
		  document.getElementById("prefApplicationLabel").value,
		  document.getElementById("prefApplicationCommand").value,
		  document.getElementById("prefApplicationArguments").value);
	} else {
		var i = document.getElementById("prefListboxApplication").selectedIndex;
	    if ( i != -1 ) {
			var applic = xmlhttp.responseXML.getElementsByTagName(downloadwithOS).item(0).getElementsByTagName("application").item(i - 1);
			window.opener.addApplication(applic.getElementsByTagName("identification").item(0).firstChild.nodeValue,
			  applic.getElementsByTagName("label").item(0).firstChild.nodeValue,
			  applic.getElementsByTagName("command").item(0).firstChild.nodeValue,
			  applic.getElementsByTagName("arguments").item(0).firstChild.nodeValue);
		}
	}
}

function enableCustom() {
	document.getElementById("customGroup").removeAttribute("hidden");
	document.getElementById("downloadGroup").setAttribute("hidden", "true");
}

function enableDownload() {
	document.getElementById("downloadGroup").removeAttribute("hidden");
	document.getElementById("customGroup").setAttribute("hidden", "true");
}

function initDownloadwithPrefCreate() {
	// Configure application
	// create a file object for the external program
	try {        
		/* unix, linux and others */
    	document.getElementById("prefDownloading").removeAttribute("hidden");
		xmlhttp.open("GET", "http://downloadwith.mozdev.org/configurations/configurations.xml",true);
		xmlhttp.onreadystatechange = function() {
			if (xmlhttp.readyState==4) {
		    	document.getElementById("prefDownloading").setAttribute("hidden", "true");
		    	var applic = xmlhttp.responseXML.getElementsByTagName(downloadwithOS).item(0).getElementsByTagName("application");
				for (var i = 0; i < applic.length; i++) {
					var id = applic.item(i).getElementsByTagName("identification").item(0).firstChild.nodeValue;
					var label = applic.item(i).getElementsByTagName("label").item(0).firstChild.nodeValue;
					item=document.getElementById("prefListboxApplication").appendItem(label,id);
				}
			}
		}
		xmlhttp.send(null);
	}
	catch (e) {
		document.getElementById("prefDownloaderror").removeAttribute("hidden");
	}
}

function openCommand() {
	var res=fp.show();
	if (res==nsIFilePicker.returnOK){
		document.getElementById("prefApplicationCommand").value = fp.file.path;
	}
}